//
// Created by maxine on 6/16/25.
//

#pragma once

#include <stdint.h>
#include <iostream>
#include <format>

namespace Mutil::Console::Sequences {
    const char ESC = 0x1b;
    const char CSI = 0x9b;
    const char DCS = 0x90;
    const char OSC = 0x9d;
}

namespace Mutil::Console::General {
    const char BEL = 0x07;
    const char BS = 0x08;
    const char HT = 0x09;
    const char LF = 0x0A;
    const char VT = 0x0B;
    const char FF = 0x0C;
    const char CR = 0x0D;
    using Mutil::Console::Sequences::ESC;
    const char DEL = 0x7f;
}

namespace Mutil::Console::Cursor {
    class Movement {
    public:
        void Home() {};
        void LnCol(uint64_t line, uint64_t column) {};
        void Up(uint64_t lines) {};
        void Down(uint64_t lines) {};
        void Right(uint64_t columns) {};
        void Left(uint64_t columns) {};
        void NextLn(uint64_t lines) {};
        void PrevLn(uint64_t lines) {};
        void JmpCol(uint64_t column) {};
        std::pair<uint64_t, uint64_t> Pos() {};
        void Save() {};
        void Restore() {};
    };
}

namespace Mutil::Console::Erase {

}

namespace Mutil::Console::Graphics {
    class Format {
        void Reset() {};
        void Bold() {};
        void ResetBold() {};
        void Dim() {};
        void ResetDim() {};
        void Italic() {};
        void ResetItalic() {};
        void Underline() {};
        void ResetUnderline() {};
        void Blink() {};
        void ResetBlink() {};
        void Inverse() {};
        void ResetInverse() {};
        void Hidden() {};
        void ResetHidden() {};
        void Strikethrough() {};
        void ResetStrikethrough() {};
    };

    // Color 16
/*    const uint8_t Black = 30;
    const uint8_t Red = 31;
    const uint8_t Green = 32;
    const uint8_t Yellow = 33;
    const uint8_t Blue = 34;
    const uint8_t Magenta = 35;
    const uint8_t Cyan = 36;
    const uint8_t White = 37;
    const uint8_t Default = 39;
    const uint8_t BlackBG = 40;
    const uint8_t
    const uint8_t
    const uint8_t
    const uint8_t
    const uint8_t
    const uint8_t

    class Color16 {

    };*/


}